const { ContractFactory } = require('ethers')
const Identity = require('./build/contracts/Identity')
const Registry = require('./build/contracts/Registry')
const IdentityFactory = require('./build/contracts/IdentityFactory')

// the same wallet that deployed everything
const relayerAddr = '0x942f9CE5D9a33a82F88D233AEb3292E680230348' // 0x942f9CE5D9a33a82F88D233AEb3292E680230348
console.log('To: 0x0000000000000000000000000000000000000000')

function printDeploy(name, bytecode, data) {
	console.log(`\n\n\n${name}:\n`)
	console.log(data)
	if (data.length > bytecode.length)
		console.log(`\n\nconstructor args: ${data.slice(bytecode.length - data.length)}`)
}

const IdentityDeployer = new ContractFactory(Identity.abi, Identity.bytecode)
printDeploy('Identity', Identity.bytecode, IdentityDeployer.getDeployTransaction([], []).data)

const IdentityFactoryDeployer = new ContractFactory(IdentityFactory.abi, IdentityFactory.bytecode)
printDeploy(
	'IdentityFactory',
	IdentityFactory.bytecode,
	IdentityFactoryDeployer.getDeployTransaction(relayerAddr).data
)

const RegistryDeployer = new ContractFactory(Registry.abi, Registry.bytecode)
printDeploy('Registry', Registry.bytecode, RegistryDeployer.getDeployTransaction().data)
